
(* interpret csv file *)
structure Getcsv = struct
val base = "../2001here/" ;
fun fname elec = base ^ "ss1_" ^ elec ^ ".csv" ;
val ens = ["brin", "ginn", "molo"] ;

(* every second row starting from the first, should be just commas *)
fun mkprs (x1 :: x2 :: xs) = (x1, x2) :: mkprs xs
  | mkprs [] = []
  | mkprs _ = raise Fail "mkprs: odd length list" ;

fun testrow l = List.all (fn s => s = "") l ;

fun getf en = 
  let open List ;
    val instr = TextIO.openIn (fname en) ;
    val inp = TextIO.inputAll instr ;
    val lines = String.tokens (fn ch => ch = #"\n") inp ;
    val tokss = map (String.fields (fn ch => ch = #",")) lines ;
    val tokss' = tl tokss ; (* deleting line with cand names *)
    val prs = mkprs tokss' ;
  in (List.filter (not o testrow) (map #1 prs), map #2 prs) end ;

end ; (* struct Getcsv *)

(*
load "Getcsv" ;
open Getcsv ;
(* rows as returned by Tab.scrcsv *)
fun testcsv rows elec = 
  let
    val ([], mrs) = Getcsv.getf elec ;
    val mrs' = List.map (rev o tl o rev) mrs ;
    val dfs = ListPair.map ListPair.zip (rows', mrs') ;
    val dfs' = List.map (List.filter (not o op =)) dfs ;
    fun okdiff ("", "0") = true
      | okdiff (s1, s2) = 
	(case explode s2 of #"\"" :: s2r => 
	    (case rev s2r of #"\"" :: s2rr => s1 = implode (rev s2rr) 
	      | _ => false)
	  | _ => false)
      | okdiff _ = false ;
    val dfs'' = List.map (List.filter (not o okdiff)) dfs' ;
  in dfs'' end ;

val brin_dfs = testcsv brin_rows "brin" ;
val ginn_dfs = testcsv ginn_rows "brin" ;
val molo_dfs = testcsv molo_rows "brin" ;
*)


