
(* process teletubbies vote tables provided by Andrew Slater *)


structure Gettt = struct 
local open Getvotes in 
(* note, electorates are
Brindabella,1
Ginninderra,2
Molonglo,3
*)

(* format of votes file
fldID,batch,pindex,pref,ccode,pcode,rcand
1,0,11247,1,0,1,0
2,0,11247,2,1,1,0 
*)

(* get file names for tt election *)
val candfile = "../teletubbies/tblCands.txt" ;
val votefile = "../teletubbies/tblTestBallots.txt" ;

val candinfo = Getcands.getcands candfile ;

(* getvotes : int -> (voteid * int list) list
  get votes for electorate number n, n = 0,1,2 *)
fun getvotes (n as 3) = 
  let val _ = print "Gettt.getvotes\n" ;
    val files = [votefile] ;
    val evec = #evec (candinfo n) ;
    val ocls = (getvf evec) files ;
  in ocls end ;

(* putvotes : (voteid * int list) list * string -> unit 
  get votes for electorate number n, n = 0,1,2 *)
fun putvotes (idvotes, file) = 
  let open TextIO ;
    val ostr = openOut file ;
    fun putvote (vid, vote) = 
      let val vstr = RPV.il2svote vote ;
      in output1 (ostr, chr (size vstr)) ; output (ostr, vstr) end ;
  in app putvote idvotes ; closeOut ostr end ;

end ; (* local open Getvotes *)
end ; (* structure Gettt *)

(* 
load "Gettt" ; open Gettt ;
val votes = (getvotes 3) ;
val nv = length votes ;
val svotes = (map (RPV.il2svote o #2)) votes ;
val _ = putvotes (votes, "ttvotes") ;
val (nv', svotes') = RPV.readsvotes "ttvotes" ~1 ;
val votes' = map RPV.s2ilvote svotes' ; 
val true = (map #2 votes) = votes' ;
val nelecs = [1,2,3,4,5,6,7] ;

fun commLot cnt cands = cnt mod length cands 
  handle exn => raise Fail ("commLot: " ^ exnMessage exn) ;

load "Count" ; load "Tab" ;

(* count for varying number elected *)
fun docount nelec = 
  let 
    val nelstr = Int.toString nelec ;
    val (nc, ne, nfv, decd, commLot, votes) =
      (#ncand (candinfo 3), nelec, 
      nv, [], commLot, svotes) ;
    val info = Count.prefCount (nc, ne, nfv, decd, commLot, votes) ;
    val base = "../teletubbies/results" ^ nelstr ;
    val () = Tab.prscr info base ;
    val () = Tab.prdist info base ;
  in () end ;

app docount nelecs ;
*)
